<div class="crm-container" id="paymentprocessor-webhooks">
  <h1 crm-page-title>{{ts('Payment Processor Webhooks')}}</h1>

  <form name="myForm" crm-ui-id-scope>

    <div crm-ui-accordion="{title: ts('Filters')}">
      <div class="crm-block">
        <div class="crm-group">

          <div crm-ui-field="{name: 'myForm.statuses', title: ts('Status')}">
            <select type="text" ng-model="$ctrl.statusFilter" >
              <option value="">{{ts('- Any -')}}</option>
              <option value="new">{{ts('New')}}</option>
              <option value="processing">{{ts('Processing')}}</option>
              <option value="success">{{ts('Success')}}</option>
              <option value="error">{{ts('Error')}}</option>
            </select>
          </div>

          <div crm-ui-field="{name: 'myForm.processor', title: ts('Processor')}">
            <select type="text" ng-model="$ctrl.processorFilter" >
              <option value="">{{ts('- Any -')}}</option>
              <option ng-repeat="processor in $ctrl.processors"
                      value="{{processor.id}}"
                      >{{processor.processorType}}:
                      {{processor.processorName}}:
                      {{:: processor.isTest ? ts('Test') : ts('Live') }}
                      ({{ts('%count webhooks', {count:processor.webhooksCount}) }})
                      </option>
            </select>
          </div>

          <div crm-ui-field="{name: 'myForm.event', title: ts('Event ID')}">
            <input
              crm-ui-id="myForm.event_id"
              name="event_id"
              ng-model="$ctrl.eventFilter"
              class="crm-form-text"
              />
          </div>
        </div>
      </div>

      <div class="pager">
        <div class="pager-info">Showing {{$ctrl.offset+1}} &ndash; {{$ctrl.offset + $ctrl.events.length}} of {{$ctrl.resultsCount}} </div>
        <div class="pager-buttons">
          <button
              ng-if="$ctrl.offset > 0"
              ng-click="$ctrl.changePage(-1)"
              >{{ts('Previous page')}}</button>
          <button
              ng-if="$ctrl.offset + $ctrl.limit < $ctrl.resultsCount"
              ng-click="$ctrl.changePage(1)"
              >{{ts('Next page')}}</button>
          <button ng-click="$ctrl.load()">{{ts('Search / Reload')}}</button>
        </div>
      </div>
    </div>
  </form>

  <table id="paymentprocessor-webhooks-table" >
    <thead>
      <tr>
        <th>Status</th>
        <th>Time</th>
        <th>Processor</th>
        <th>Event ID</th>
        <th>Message</th>
        <th>Actions</th>
      </tr>
    </thead>
    <tbody>
      <tr ng-repeat="(idx, row) in $ctrl.events" ng-class="{selected: (row.id == $ctrl.selectedRow)}">
        <td ng-class="row['status'] + ' text-center'" title="{{ $ctrl.statusMap[row['status']].title }}">{{ $ctrl.statusMap[row['status']].content }}</td>
        <td><span title="Date received">{{row['created_date']}}</span> <span ng-if="row['processed_date']" title="Date processed">| {{row['processed_date']}}</span></td>
        <td><span title="Test processor" ng-if="row['payment_processor.is_test'] == 1" >🧪 </span>{{row['payment_processor.name']}}</td>
        <td>{{row['event_id']}}</td>
        <td>{{$ctrl.abbreviate(row['message'])}}</td>
        <td>
          <a href ng-click="$ctrl.selectedRow = row.id" ng-if="$ctrl.selectedRow != row.id">Details</a>
          <a href ng-click="$ctrl.selectedRow = null" ng-if="$ctrl.selectedRow == row.id">Hide details</a> &nbsp;
          <a href ng-click="$ctrl.delete(row.id)">Delete</a> &nbsp;
          <a href ng-click="$ctrl.retry(row.id)">Retry</a>

          <div class="details" ng-if="$ctrl.selectedRow == row.id">
            <p>
              Payment Processor:
              <em>{{row['payment_processor.name']}}</em>
              (<strong ng-if="row['payment_processor.is_test'] == 1" >Test</strong><strong ng-if="row['payment_processor.is_test'] != 1" >Live</strong>
              ID: <code>{{row['payment_processor_id']}}</code>)
            </p>
            <p>Status: {{ $ctrl.statusMap[row['status']].title }}</p>
            <p>
              Identifier: <code>{{row.identifier}}</code>
              Type: <code>{{row.trigger}}</code>
            </p>
            <p>Full message:</p>
            <div class="message">{{row.message}}</div>
            <p>
              Raw data:
            </p>
            <div class="raw">{{row.data}}</div>
          </div>
        </td>
      </tr>
    </tbody>
  </table>
  <br />

  <!-- this is repeated code, @todo tidy into separate directive? -->
  <div class="pager">
    <div class="pager-info">Showing {{$ctrl.offset+1}} &ndash; {{$ctrl.offset + $ctrl.events.length}} of {{$ctrl.resultsCount}} </div>
    <div class="pager-buttons">
      <button
          ng-if="$ctrl.offset > 0"
          ng-click="$ctrl.changePage(-1)"
          >{{ts('Previous page')}}</button>
      <button
          ng-if="$ctrl.offset + $ctrl.limit < $ctrl.resultsCount"
          ng-click="$ctrl.changePage(1)"
          >{{ts('Next page')}}</button>
      <button ng-click="$ctrl.load()">{{ts('Search / Reload')}}</button>
    </div>
  </div>

</div>
